import type { ICharacterShape } from "../../../Interfaces/Particles/Shape/ICharacterShape";
import type { IImageShape } from "../../../Interfaces/Particles/Shape/IImageShape";
import type { IOptionLoader } from "../../../Interfaces/IOptionLoader";
import type { IPolygonShape } from "../../../Interfaces/Particles/Shape/IPolygonShape";
import type { IShape } from "../../../Interfaces/Particles/Shape/IShape";
import type { RecursivePartial } from "../../../../Types/RecursivePartial";
import type { ShapeData } from "../../../../Types/ShapeData";
import { ShapeType } from "../../../../Enums/Types/ShapeType";
import type { SingleOrMultiple } from "../../../../Types/SingleOrMultiple";
import { Stroke } from "../Stroke";
export declare class Shape implements IShape, IOptionLoader<IShape> {
    get image(): SingleOrMultiple<IImageShape>;
    set image(value: SingleOrMultiple<IImageShape>);
    get custom(): ShapeData;
    set custom(value: ShapeData);
    get images(): SingleOrMultiple<IImageShape>;
    set images(value: SingleOrMultiple<IImageShape>);
    get stroke(): SingleOrMultiple<Stroke>;
    set stroke(_value: SingleOrMultiple<Stroke>);
    get character(): SingleOrMultiple<ICharacterShape>;
    set character(value: SingleOrMultiple<ICharacterShape>);
    get polygon(): SingleOrMultiple<IPolygonShape>;
    set polygon(value: SingleOrMultiple<IPolygonShape>);
    type: SingleOrMultiple<ShapeType | keyof typeof ShapeType | string>;
    options: ShapeData;
    constructor();
    load(data?: RecursivePartial<IShape>): void;
    private loadShape;
}
