(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./Remover"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.loadExternalRemoveInteraction = void 0;
    const Remover_1 = require("./Remover");
    async function loadExternalRemoveInteraction(engine) {
        await engine.addInteractor("externalRemove", (container) => new Remover_1.Remover(container));
    }
    exports.loadExternalRemoveInteraction = loadExternalRemoveInteraction;
});
