<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace MapModule\Controller;

use Cake\Http\Exception\MethodNotAllowedException;
use Cake\Http\Exception\NotFoundException;
use Cake\ORM\TableRegistry;
use itnovum\openITCOCKPIT\Core\AngularJS\Api;
use itnovum\openITCOCKPIT\Core\KeyValueStore;
use itnovum\openITCOCKPIT\Database\PaginateOMat;
use itnovum\openITCOCKPIT\Filter\MapFilter;
use MapModule\Model\Entity\Map;
use MapModule\Model\Table\MapsTable;

/**
 * Class MapsController
 * @package MapModule\Controller
 */
class MapsController extends AppController {

    public function index() {
        if (!$this->isApiRequest()) {
            //Only ship template for AngularJs
            return;
        }

        $MapFilter = new MapFilter($this->request);

        /** @var MapsTable $MapsTable */
        $MapsTable = TableRegistry::getTableLocator()->get('MapModule.Maps');

        $PaginateOMat = new PaginateOMat($this, $this->isScrollRequest(), $MapFilter->getPage());

        $all_maps = $MapsTable->getMapsIndex($MapFilter, $PaginateOMat);

        $maps = [];
        foreach ($all_maps as $key => $all_map) {
            /** @var Map $all_map */
            $map = $all_map->toArray();
            $maps[] = $map;
        }
        $this->set('all_maps', $maps);
        $this->viewBuilder()->setOption('serialize', ['all_maps']);
    }
}
