<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
declare(strict_types=1);

namespace App\Controller;

use App\Model\Table\HoststatusTable;
use App\Model\Table\ServicestatusTable;
use Cake\ORM\TableRegistry;


/**
 * Class DashboardController
 * @package App\Controller
 */
class DashboardController extends AppController {

    public function index() {
        if (!$this->isApiRequest()) {
            return;
        }

        /** @var HoststatusTable $HoststatusTable */
        $HoststatusTable = TableRegistry::getTableLocator()->get('Hoststatus');
        /** @var ServicestatusTable $ServicestatusTable */
        $ServicestatusTable = TableRegistry::getTableLocator()->get('Servicestatus');

        $hostCount = $HoststatusTable->getHoststatusCountForDashboard();
        $serviceCount = $ServicestatusTable->getServicestatusCountForDashboard();

        $hostSummaryState = $HoststatusTable->getHoststateSummary();
        $serviceSummaryState = $ServicestatusTable->getServicestateSummary();

        $this->set('hostCount', $hostCount);
        $this->set('serviceCount', $serviceCount);
        $this->set('hostSummaryState', $hostSummaryState);
        $this->set('serviceSummaryState', $serviceSummaryState);

        $this->viewBuilder()->setOption('serialize', [
            'hostCount',
            'serviceCount',
            'hostSummaryState',
            'serviceSummaryState'
        ]);
    }
}
