<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace App\Model\Entity;

use Cake\I18n\FrozenTime;
use Cake\ORM\Entity;

/**
 * Usergroup Entity
 *
 * @property int $id
 * @property string $name
 * @property string|null $description
 * @property FrozenTime $created
 * @property FrozenTime $modified
 *
 * @property User[] $users
 */
class Usergroup extends Entity {

    /**
     * Fields that can be mass assigned using newEntity() or patchEntity().
     *
     * Note that when '*' is set to true, this allows all unspecified fields to
     * be mass assigned. For security purposes, it is advised to set '*' to false
     * (or remove it), and explicitly make individual fields accessible as needed.
     *
     * @var array
     */
    protected $_accessible = [
        'name'        => true,
        'description' => true,
        'created'     => true,
        'modified'    => true,
        'users'       => true
    ];

    public function parentNode() {
        return null;
    }
}
