<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

declare(strict_types=1);

namespace App\Model\Table;

use Acl\Model\Table\AcosTable;
use Acl\Model\Table\ArosTable;
use App\Model\Entity\ArosAco;
use Cake\Datasource\EntityInterface;
use Cake\ORM\Association\BelongsTo;
use Cake\ORM\RulesChecker;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * ArosAcos Model
 *
 * @property ArosTable&BelongsTo $Aros
 * @property AcosTable&BelongsTo $Acos
 *
 * @method ArosAco get($primaryKey, $options = [])
 * @method ArosAco newEntity($data = null, array $options = [])
 * @method ArosAco[] newEntities(array $data, array $options = [])
 * @method ArosAco|false save(EntityInterface $entity, $options = [])
 * @method ArosAco saveOrFail(EntityInterface $entity, $options = [])
 * @method ArosAco patchEntity(EntityInterface $entity, array $data, array $options = [])
 * @method ArosAco[] patchEntities($entities, array $data, array $options = [])
 * @method ArosAco findOrCreate($search, callable $callback = null, $options = [])
 */
class ArosAcosTable extends Table {
    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config): void {
        parent::initialize($config);

        $this->setTable('aros_acos');
        $this->setDisplayField('id');
        $this->setPrimaryKey('id');

        $this->belongsTo('Aros', [
            'foreignKey' => 'aro_id',
            'joinType'   => 'INNER',
        ]);
        $this->belongsTo('Acos', [
            'foreignKey' => 'aco_id',
            'joinType'   => 'INNER',
        ]);
    }

    /**
     * Default validation rules.
     *
     * @param Validator $validator Validator instance.
     * @return Validator
     */
    public function validationDefault(Validator $validator): Validator {
        return $validator;
    }

    /**
     * Returns a rules checker object that will be used for validating
     * application integrity.
     *
     * @param RulesChecker $rules The rules object to be modified.
     * @return RulesChecker
     */
    public function buildRules(RulesChecker $rules): RulesChecker {
        return $rules;
    }
}
