<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace App\Model\Table;

use App\Model\Entity\Mapping;
use Cake\Datasource\EntityInterface;
use Cake\ORM\Association\BelongsTo;
use Cake\ORM\Table;
use Cake\Validation\Validator;

/**
 * Mapping Model
 *
 * @property BelongsTo $Types
 *
 * @method Mapping get($primaryKey, $options = [])
 * @method Mapping newEntity($data = null, array $options = [])
 * @method Mapping[] newEntities(array $data, array $options = [])
 * @method Mapping|bool save(EntityInterface $entity, $options = [])
 * @method Mapping patchEntity(EntityInterface $entity, array $data, array $options = [])
 * @method Mapping[] patchEntities($entities, array $data, array $options = [])
 * @method Mapping findOrCreate($search, callable $callback = null, $options = [])
 */
class MappingTable extends Table {

    /**
     * Initialize method
     *
     * @param array $config The configuration for the Table.
     * @return void
     */
    public function initialize(array $config): void {
        parent::initialize($config);

        $this->setTable('mapping');
        $this->setDisplayField('id');
        $this->setPrimaryKey('id');
    }

    /**
     * Default validation rules.
     *
     * @param Validator $validator Validator instance.
     * @return Validator
     */
    public function validationDefault(Validator $validator): Validator {
        $validator
            ->integer('id')
            ->allowEmptyString('id', null, 'create');

        $validator
            ->requirePresence('uuid', 'create')
            ->notEmptyString('uuid');

        $validator
            ->requirePresence('display_name', 'create')
            ->notEmptyString('display_name');

        return $validator;
    }
}
