<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-tachometer-alt"></i> <?php echo __('Dashboard'); ?>
    </li>
</ol>
<div class="row">
    <div class="col-xl-12">
        <div id="widget-container" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?= __('Dashboard'); ?>
                    <span class="fw-300">
                        <i> <?= __('status overview'); ?></i>
                    </span>
                </h2>
            </div>
            <div role="content" class="card-body">
                <div role="content" class="card-body">
                    <div class="container-fluid">
                        <div class="row margin-top-5">
                            <div class="col-lg-3 col-xs-6">
                                <div class="small-box bg-aqua">
                                    <div class="inner">
                                        <h3>{{ dashboardData.hostCount }}</h3>

                                        <p><?php echo __('Total Hosts'); ?></p>
                                    </div>
                                    <div class="icon">
                                        <i class="fa fa-desktop"></i>
                                    </div>
                                    <?php if ($this->Acl->hasPermission('index', 'hosts')): ?>
                                        <a ui-sref="HostsIndex" class="small-box-footer">
                                            <?php echo __('View'); ?> <i class="fa fa-arrow-circle-right"></i>
                                        </a>
                                    <?php else: ?>
                                        <span class="small-box-footer">&nbsp;<!-- Nice HTML --></span>
                                    <?php endif; ?>
                                </div>
                            </div>
                            <div class="col-lg-2 col-xs-6">
                                <div class="small-box bg-green">
                                    <div class="inner">
                                        <h3>{{ dashboardData.hostSummaryState.up }}</h3>

                                        <p><?php echo __('Hosts Up'); ?></p>
                                    </div>
                                    <div class="icon">
                                        <i class="fa fa-check"></i>
                                    </div>
                                    <?php if ($this->Acl->hasPermission('index', 'hosts')): ?>
                                        <a ui-sref="HostsIndex({'statename':'up'})" class="small-box-footer">
                                            <?php echo __('View'); ?> <i class="fa fa-arrow-circle-right"></i>
                                        </a>
                                    <?php else: ?>
                                        <span class="small-box-footer">&nbsp;<!-- Nice HTML --></span>
                                    <?php endif; ?>
                                </div>
                            </div>
                            <div class="col-lg-2 col-xs-6">
                                <div class="small-box bg-red">
                                    <div class="inner">
                                        <h3>{{ dashboardData.hostSummaryState.down }}</h3>

                                        <p><?php echo __('Hosts Down'); ?></p>
                                    </div>
                                    <div class="icon">
                                        <i class="fa fa-exclamation-triangle"></i>
                                    </div>
                                    <?php if ($this->Acl->hasPermission('index', 'hosts')): ?>
                                        <a ui-sref="HostsIndex({'statename':'down'})" class="small-box-footer">
                                            <?php echo __('View'); ?> <i class="fa fa-arrow-circle-right"></i>
                                        </a>
                                    <?php else: ?>
                                        <span class="small-box-footer">&nbsp;<!-- Nice HTML --></span>
                                    <?php endif; ?>
                                </div>
                            </div>
                            <div class="col-lg-2 col-xs-6">
                                <div class="small-box bg-gray">
                                    <div class="inner">
                                        <h3>{{ dashboardData.hostSummaryState.unreachable }}</h3>

                                        <p><?php echo __('Hosts Unreachable'); ?></p>
                                    </div>
                                    <div class="icon">
                                        <i class="fa fa-question-circle"></i>
                                    </div>
                                    <?php if ($this->Acl->hasPermission('index', 'hosts')): ?>
                                        <a ui-sref="HostsIndex({'statename':'unreachable'})"
                                           class="small-box-footer">
                                            <?php echo __('View'); ?> <i class="fa fa-arrow-circle-right"></i>
                                        </a>
                                    <?php else: ?>
                                        <span class="small-box-footer">&nbsp;<!-- Nice HTML --></span>
                                    <?php endif; ?>
                                </div>
                            </div>
                        </div>


                        <div class="row margin-top-5">
                            <div class="col-lg-3 col-xs-6">
                                <div class="small-box bg-light-blue">
                                    <div class="inner">
                                        <h3>{{ dashboardData.serviceCount }}</h3>

                                        <p><?php echo __('Total Service'); ?></p>
                                    </div>
                                    <div class="icon">
                                        <i class="fa fa-cogs"></i>
                                    </div>
                                    <?php if ($this->Acl->hasPermission('index', 'services')): ?>
                                        <a ui-sref="ServicesIndex" class="small-box-footer">
                                            <?php echo __('View'); ?> <i class="fa fa-arrow-circle-right"></i>
                                        </a>
                                    <?php else: ?>
                                        <span class="small-box-footer">&nbsp;<!-- Nice HTML --></span>
                                    <?php endif; ?>
                                </div>
                            </div>
                            <div class="col-lg-2 col-xs-6">
                                <div class="small-box bg-green">
                                    <div class="inner">
                                        <h3>{{ dashboardData.serviceSummaryState.ok }}</h3>

                                        <p><?php echo __('Total Service'); ?></p>
                                    </div>
                                    <div class="icon">
                                        <i class="fa fa-check"></i>
                                    </div>
                                    <?php if ($this->Acl->hasPermission('index', 'services')): ?>
                                        <a ui-sref="ServicesIndex({'statename':'ok'})" class="small-box-footer">
                                            <?php echo __('View'); ?> <i class="fa fa-arrow-circle-right"></i>
                                        </a>
                                    <?php else: ?>
                                        <span class="small-box-footer">&nbsp;<!-- Nice HTML --></span>
                                    <?php endif; ?>
                                </div>
                            </div>
                            <div class="col-lg-2 col-xs-6">
                                <div class="small-box bg-orange">
                                    <div class="inner">
                                        <h3>{{ dashboardData.serviceSummaryState.warning }}</h3>

                                        <p><?php echo __('Total Service'); ?></p>
                                    </div>
                                    <div class="icon">
                                        <i class="fa fa-exclamation-triangle"></i>
                                    </div>
                                    <?php if ($this->Acl->hasPermission('index', 'services')): ?>
                                        <a ui-sref="ServicesIndex({'statename':'warning'})"
                                           class="small-box-footer">
                                            <?php echo __('View'); ?> <i class="fa fa-arrow-circle-right"></i>
                                        </a>
                                    <?php else: ?>
                                        <span class="small-box-footer">&nbsp;<!-- Nice HTML --></span>
                                    <?php endif; ?>
                                </div>
                            </div>
                            <div class="col-lg-2 col-xs-6">
                                <div class="small-box bg-red">
                                    <div class="inner">
                                        <h3>{{ dashboardData.serviceSummaryState.critical }}</h3>

                                        <p><?php echo __('Total Service'); ?></p>
                                    </div>
                                    <div class="icon">
                                        <i class="fa fa-exclamation-triangle"></i>
                                    </div>
                                    <?php if ($this->Acl->hasPermission('index', 'services')): ?>
                                        <a ui-sref="ServicesIndex({'statename':'critical'})"
                                           class="small-box-footer">
                                            <?php echo __('View'); ?> <i class="fa fa-arrow-circle-right"></i>
                                        </a>
                                    <?php else: ?>
                                        <span class="small-box-footer">&nbsp;<!-- Nice HTML --></span>
                                    <?php endif; ?>
                                </div>
                            </div>
                            <div class="col-lg-2 col-xs-6">
                                <div class="small-box bg-gray">
                                    <div class="inner">
                                        <h3>{{ dashboardData.serviceSummaryState.unknown }}</h3>

                                        <p><?php echo __('Total Service'); ?></p>
                                    </div>
                                    <div class="icon">
                                        <i class="fa fa-question-circle"></i>
                                    </div>
                                    <?php if ($this->Acl->hasPermission('index', 'services')): ?>
                                        <a ui-sref="ServicesIndex({'statename':'unknown'})"
                                           class="small-box-footer">
                                            <?php echo __('View'); ?> <i class="fa fa-arrow-circle-right"></i>
                                        </a>
                                    <?php else: ?>
                                        <span class="small-box-footer">&nbsp;<!-- Nice HTML --></span>
                                    <?php endif; ?>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

