<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <?php if ($this->Acl->hasPermission('index', 'usergroups')): ?>
            <a ui-sref="UsergroupsIndex">
                <i class="fa fa-users"></i> <?php echo __('User roles'); ?>
            </a>
        <?php else: ?>
            <i class="fa fa-users"></i> <?php echo __('User roles'); ?>
        <?php endif; ?>
    </li>

    <li class="breadcrumb-item">
        <i class="fa fa-list"></i> <?php echo __('Overview'); ?>
    </li>
</ol>

<!-- ANGAULAR DIRECTIVES -->
<mass-delete></mass-delete>

<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('User roles'); ?>
                    <span class="fw-300"><i><?php echo __('overview'); ?></i></span>
                </h2>
                <div class="panel-toolbar">
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>
                    <?php if ($this->Acl->hasPermission('add', 'usergroups')): ?>
                        <button class="btn btn-xs btn-success mr-1 shadow-0" ui-sref="UsergroupsAdd">
                            <i class="fas fa-plus"></i> <?php echo __('New'); ?>
                        </button>
                    <?php endif; ?>
                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?php echo __('Filter'); ?>
                    </button>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">

                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?php echo __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fas fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by name'); ?>"
                                                   ng-model="filter.Usergroups.name"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fas fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by description'); ?>"
                                                   ng-model="filter.Usergroups.description"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?php echo __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <!-- Filter End -->

                    <div class="frame-wrap">
                        <table class="table table-striped m-0 table-bordered table-hover table-sm">
                            <thead>
                            <tr>
                                <th class="no-sort width-15">
                                    <i class="fa fa-check-square"></i>
                                </th>
                                <th class="no-sort" ng-click="orderBy('Usergroups.name')">
                                    <i class="fa" ng-class="getSortClass('Usergroups.name')"></i>
                                    <?php echo __('Name'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('Usergroups.description')">
                                    <i class="fa" ng-class="getSortClass('Usergroups.description')"></i>
                                    <?php echo __('Description'); ?>
                                </th>
                                <th class="no-sort text-center">
                                    <i class="fa fa-users"></i>
                                </th>
                                <th class="no-sort text-center">
                                    <i class="fa fa-cog"></i>
                                </th>
                            </tr>
                            </thead>
                            <tbody>
                            <tr ng-repeat="usergroup in Usergroups">
                                <td class="text-center" class="width-15">
                                    <?php if ($this->Acl->hasPermission('delete', 'usergroups')): ?>
                                        <input type="checkbox" ng-if="usergroup.usercount == 0"
                                               ng-model="massChange[usergroup.id]">
                                    <?php endif; ?>
                                </td>
                                <td>{{usergroup.name}}</td>
                                <td>{{usergroup.description}}</td>
                                <td class="text-center">
                                    <?php if ($this->Acl->hasPermission('index', 'users')): ?>
                                        <a ui-sref="UsersIndex({usergroup_id: usergroup.id})"
                                           ng-show="usergroup.usercount > 0">
                                            {{usergroup.usercount}}
                                        </a>
                                        <span ng-hide="usergroup.usercount > 0">
                                             {{usergroup.usercount}}
                                        </span>
                                    <?php endif; ?>
                                </td>

                                <td class="width-50">
                                    <div class="btn-group btn-group-xs" role="group">
                                        <?php if ($this->Acl->hasPermission('edit', 'usergroups')): ?>
                                            <a ui-sref="UsergroupsEdit({id: usergroup.id})"
                                               class="btn btn-default btn-lower-padding">
                                                <i class="fa fa-cog"></i>
                                            </a>
                                        <?php else: ?>
                                            <a href="javascript:void(0);"
                                               class="btn btn-default btn-lower-padding disabled">
                                                <i class="fa fa-cog"></i></a>
                                        <?php endif; ?>
                                        <button type="button"
                                                class="btn btn-default dropdown-toggle btn-lower-padding"
                                                data-toggle="dropdown">
                                            <i class="caret"></i>
                                        </button>
                                        <div class="dropdown-menu dropdown-menu-right">
                                            <?php if ($this->Acl->hasPermission('edit', 'usergroups')): ?>
                                                <a ui-sref="UsergroupsEdit({id: usergroup.id})"
                                                   class="dropdown-item">
                                                    <i class="fa fa-cog"></i>
                                                    <?php echo __('Edit'); ?>
                                                </a>
                                            <?php endif; ?>
                                            <?php if ($this->Acl->hasPermission('delete', 'usergroups')): ?>
                                                <div class="dropdown-divider"></div>
                                                <a ng-click="confirmDelete(getObjectForDelete(usergroup))"
                                                   href="javascript:void(0);"
                                                   class="dropdown-item txt-color-red">
                                                    <i class="fa fa-trash"></i>
                                                    <?php echo __('Delete'); ?>
                                                </a>
                                            <?php endif; ?>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                        <div class="margin-top-10" ng-show="Usergroups.length == 0">
                            <div class="text-center text-danger italic">
                                <?php echo __('No entries match the selection'); ?>
                            </div>
                        </div>
                        <div class="row margin-top-10 margin-bottom-10">
                            <?php if ($this->Acl->hasPermission('delete', 'usergroups')): ?>
                                <div class="col-xs-12 col-md-2 text-muted text-center">
                                    <span ng-show="selectedElements > 0">({{selectedElements}})</span>
                                </div>
                                <div class="col-xs-12 col-md-2">
                                    <span ng-click="selectAll()" class="pointer">
                                        <i class="fas fa-lg fa-check-square"></i>
                                        <?php echo __('Select all'); ?>
                                    </span>
                                </div>
                                <div class="col-xs-12 col-md-2">
                                    <span ng-click="undoSelection()" class="pointer">
                                        <i class="fas fa-lg fa-square"></i>
                                        <?php echo __('Undo selection'); ?>
                                    </span>
                                </div>
                                <?php if ($this->Acl->hasPermission('delete', 'usergroups')): ?>
                                    <div class="col-xs-12 col-md-2 txt-color-red">
                                        <span ng-click="confirmDelete(getObjectsForDelete())" class="pointer">
                                            <i class="fas fa-trash"></i>
                                            <?php echo __('Delete selected'); ?>
                                        </span>
                                    </div>
                                <?php endif; ?>
                            <?php endif; ?>
                        </div>
                        <scroll scroll="scroll" click-action="changepage" ng-if="scroll"></scroll>
                        <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                        <?php echo $this->element('paginator_or_scroll'); ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
