<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace itnovum\openITCOCKPIT\Core\AngularJS\Request;


use App\Filter\BaseFilter;

class StatehistoryControllerRequest extends AngularRequest {

    /**
     * @var array
     */
    protected $filters = [
        'host'    => [
            'like' => [
                'StatehistoryHosts.output'
            ]
        ],
        'service' => [
            'like' => [
                'StatehistoryServices.output'
            ]
        ]
    ];

    protected $ServiceStateField = 'StatehistoryServices.state';

    protected $ServiceStateTypeField = 'StatehistoryServices.is_hardstate';

    protected $HostStateField = 'StatehistoryHosts.state';

    protected $HostStateTypeField = 'StatehistoryHosts.is_hardstate';

    public function getServiceFilters() {
        $Filter = new BaseFilter($this->getRequest());
        return $Filter->getConditionsByFilters($this->filters['service']);
    }

    public function getHostFilters() {
        $Filter = new BaseFilter($this->getRequest());
        return $Filter->getConditionsByFilters($this->filters['host']);
    }

}
