<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

declare(strict_types=1);

namespace itnovum\openITCOCKPIT\Core\Menu;

class MenuLink {

    private $name;

    private $state;

    private $controller;

    private $action;

    private $plugin;

    private $tags = [];

    private $order;

    private $icon;

    public function __construct(string $name, string $state, string $controller, string $action, string $plugin = '', string $icon = '', array $tags = [], int $order = 0) {
        $this->name = $name;
        $this->state = $state;
        $this->controller = $controller;
        $this->action = $action;
        $this->plugin = $plugin;
        $this->icon = $icon;
        $this->tags = $tags;
        $this->order = $order;
    }

    /**
     * @return int
     */
    public function getOrder(): int {
        return $this->order;
    }

    /**
     * @return bool
     */
    public function isModule() {
        return $this->plugin !== '';
    }

    /**
     * @return string
     */
    public function getLowerController(): string {
        return strtolower($this->controller);
    }

    /**
     * @return string
     */
    public function getLowerAction(): string {
        return strtolower($this->action);
    }

    /**
     * @return string
     */
    public function getLowerPlugin(): string {
        return strtolower($this->plugin);
    }

    /**
     * @return array
     */
    public function toArray(): array {
        return [
            'name'       => $this->name,
            'state'      => $this->state,
            'controller' => $this->controller,
            'action'     => $this->action,
            'plugin'     => $this->plugin,
            'tags'       => $this->tags,
            'order'      => $this->order,
            'icon'       => $this->icon
        ];
    }

}
