<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace itnovum\openITCOCKPIT\InitialDatabase;

use Cake\Datasource\EntityInterface;
use Cake\ORM\Entity;
use Cake\ORM\Table;
use Cake\Utility\Inflector;

class Importer implements ImporterInterface {

    /**
     * @var Table
     */
    protected $Table;

    public function __construct(Table $Table) {
        $this->Table = $Table;
    }

    /**
     * @return bool
     */
    public function isTableEmpty() {
        // SELECT COUNT(*) count FROM <TABLE>
        $result = $this->Table->find()->count();
        $result = (int)$result;

        return $result === 0;
    }

    /**
     * @return array
     */
    public function getData() {
        return [];
    }

    /**
     * @param Entity $entity
     * @param array $record
     * @return EntityInterface
     */
    public function patchEntityAndKeepAllIds(EntityInterface $entity, array $record) {
        $associatedAccessibleFields = [];
        foreach ($this->Table->associations() as $association) {
            $associationKey = $association->getName(); //cakephp >= 4.1
            //$associationKey = strtolower(Inflector::underscore($association->getName())); // cakephp <= 4.1
            $associatedAccessibleFields[$associationKey] = ['accessibleFields' => ['*' => true]];
        }

        $entity = $this->Table->patchEntity($entity, $record, [
            'validate'         => false,
            'accessibleFields' => ['*' => true],
            'associated'       => $associatedAccessibleFields
        ]);
        return $entity;
    }

}
