angular.module('openITCOCKPIT')
    .controller('AutomapsIndexController', function($scope, $http, $interval){

        /** Filter settings **/
        var defaultFilter = function(){
            $scope.stateOk = true;
            $scope.stateWarning = true;
            $scope.stateCritical = true;
            $scope.stateUnknown = true;
            $scope.current_state = [];
            $scope.filter_host_name = '';
            $scope.filter_service_name = '';
            $scope.showFilter = false;
        };

        defaultFilter();
        /** End filter Settings **/

        $scope.showLabel = false;
        $scope.minified = true;

        $scope.init = true;

        $scope.triggerFilter = function(){
            $scope.showFilter = !$scope.showFilter === true;
        };

        $scope.resetFilter = function(){
            defaultFilter();
        };

        $scope.load = function(){
            $http.get("/services/automap.json", {
                params: {
                    'filter[Servicestatus.current_state][]': $scope.current_state,
                    'filter[HostMapping.display_name]': $scope.filter_host_name,
                    'filter[ServiceMapping.display_name]': $scope.filter_service_name,
                }
            }).then(function(result){
                $scope.services = result.data.services;
                $scope.paging = result.data.paging;
                $scope.scroll = result.data.scroll;
                $scope.init = false;
            });

        };

        $scope.getObjectsForExternalCommandHost = function(){
            return [{
                Host: {
                    uuid: $scope. hoststatus.hostname
                }
            }];
        };

        $scope.getObjectsForExternalCommandService = function(){
            return [{
                Host: {
                    uuid: $scope. servicestatus.hostname
                },
                Service: {
                    uuid: $scope.servicestatus.service_description
                }
            }];
        };

        $scope.changepage = function(page){
            if(page !== $scope.currentPage){
                $scope.currentPage = page;
                $scope.load();
            }
        };

        $scope.changeMode = function(val){
            $scope.useScroll = val;
            $scope.load();
        };

        $scope.$watchGroup(['stateOk', 'stateWarning', 'stateCritical', 'stateUnknown', 'filter_host_name', 'filter_service_name'], function(){
            if($scope.init){
                return;
            }
            $scope.current_state = [];
            if($scope.stateOk){
                $scope.current_state.push('ok');
            }
            if($scope.stateWarning){
                $scope.current_state.push('warning');
            }
            if($scope.stateCritical){
                $scope.current_state.push('critical');
            }
            if($scope.stateUnknown){
                $scope.current_state.push('unknown');
            }
            $scope.load();
        });

        $scope.Timer = $interval($scope.load, 30000);

        $scope.$on("$destroy", function(){
            if(angular.isDefined($scope.Timer)){
                $interval.cancel($scope.Timer);
            }
        });

        $scope.load();
    });
