angular.module('openITCOCKPIT').directive('disableHostFlapDetection', function($http, $timeout){
    return {
        restrict: 'E',
        templateUrl: '/angular/disable_host_flap_detection.html',

        controller: function($scope){

            var objects = {};
            var callbackName = false;

            $scope.isDisableingHostFlapDetection = false;

            $scope.setDisableHostFlapDetectionObjects = function(_objects){
                objects = _objects;
            };

            $scope.setDisableHostFlapDetectionCallback = function(_callback){
                callbackName = _callback;
            };


            $scope.doDisableHostFlapDetection = function(){
                var count = Object.keys(objects).length;
                var i = 0;
                $scope.percentage = 0;
                $scope.isDisableingHostFlapDetection = true;


                $scope.percentage = Math.round(i / count * 100);
                for(var id in objects){
                    var object = objects[id];
                    i++;
                    $scope.percentage = Math.round(i / count * 100);

                    $http.get("/externalcommands/flap_detection.json", {
                        params: {
                            angular: true,
                            host_uuid: object.Host.uuid,
                            type: 'host',
                            enabled: 0
                        }
                    });
                }

                //Call callback function if given
                if(callbackName){
                    $scope[callbackName]();
                }
                $timeout(function(){
                    $scope.isDisableingHostFlapDetection = false;
                    $scope.percentage = 0;
                    $('#angularDisableHostFalpDetectionModal').modal('hide');
                }, 500);
            };

        },

        link: function($scope, element, attr){
            $scope.disableHostFlapDetection = function(objects){
                if(Object.keys(objects).length === 0){
                    return;
                }

                if(attr.hasOwnProperty('callback')){
                    $scope.setDisableHostFlapDetectionCallback(attr.callback);
                }

                $('#angularDisableHostFalpDetectionModal').modal('show');
                $scope.setDisableHostFlapDetectionObjects(objects);
            };
        }
    };
});
