angular.module('openITCOCKPIT').directive('hostStatusDetailsModal', function($http, $state, $interval, NotyService){
    return {
        restrict: 'E',
        templateUrl: '/hosts/hoststatusdetailsmodal.html',

        controller: function($scope){

            $scope.modalHostname = '';
            $scope.hostdetails = false;

            $scope.showFlashMsg = function(){
                new Noty({
                    theme: 'metroui',
                    type: 'success',
                    layout: 'topCenter',
                    text: $scope.flashMshStr,
                    timeout: 4000
                }).show();

                $scope.showFlashSuccess = true;
                $scope.autoRefreshCounter = 5;
                var interval = $interval(function(){
                    $scope.autoRefreshCounter--;
                    if($scope.autoRefreshCounter === 0){
                        $scope.load();
                        $interval.cancel(interval);
                        $scope.showFlashSuccess = false;
                    }
                }, 1000);
            };

            $scope.getObjectForDowntimeDelete = function(){
                return [{
                    Host: {
                        uuid: $scope.hoststatus.hostname
                    },
                    Downtime: {
                        internal_downtime_id: $scope.downtime.internal_downtime_id
                    }
                }];
            };

            $scope.loadHostDetails = function(hoststatus){
                $scope.modalHostname = hoststatus.hostname;
                $http.get("/hosts/browser.json", {
                    params: {
                        'uuid': hoststatus.hostname
                    }
                }).then(function(result){
                    $('#angularHostStatusDetailsModal').modal('show');
                    $scope.hoststatus = result.data.hoststatus;
                    $scope.acknowledgement = result.data.acknowledgement;
                    $scope.downtime = result.data.downtime;
                });
            };

            $scope.goToHostDetails = function(){
                $('#angularHostStatusDetailsModal').modal('hide');
                $('#angularHostStatusDetailsModal').on('hidden.bs.modal', function(){
                    $state.go('hostdetails', {
                        uuid: $scope.hostdetails.hostname
                    });
                });
            };

            $scope.stateIsUp = function(){
                return parseInt($scope.hoststatus.current_state, 10) === 0;
            };

            $scope.stateIsDown = function(){
                return parseInt($scope.hoststatus.current_state, 10) === 1;
            };

            $scope.stateIsUnreachable = function(){
                return parseInt($scope.hoststatus.current_state, 10) === 2;
            };
        },

        link: function($scope, element, attr){
            $scope.showHostDetails = function(hoststatus){
                $scope.loadHostDetails(hoststatus);
            }
        }
    };
});
