<?php
// Copyright (C) <2018>  <it-novum GmbH>
//
// This file is dual licensed
//
// 1.
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, version 3 of the License.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// 2.
//  If you purchased an openITCOCKPIT Enterprise Edition you can use this file
//  under the terms of the openITCOCKPIT Enterprise Edition license agreement.
//  License agreement and license key will be shipped with the order
//  confirmation.

namespace itnovum\openITCOCKPIT\Checks\Receiver;


class CheckConfig {

    /**
     * @var array|mixed
     */
    private $config = [];

    /**
     * CheckConfig constructor.
     * @param string $path
     */
    public function __construct($path = null) {

        if ($path === null) {
            $path = __DIR__ . DS . '..' . DS . '..' . DS . '..' . DS . '..' . DS . '..' . DS . 'etc' . DS . 'hosts.json';
        }

        if (!file_exists($path)) {
            throw new \RuntimeException(sprintf('Config file "%s" not found', $path));
        }

        $this->config = json_decode(file_get_contents($path), true);
    }

    /**
     * @param $hostname
     * @return array
     */
    public function getConfigByHostName($hostname) {
        if (isset($this->config[$hostname])) {
            return $this->config[$hostname];
        }

        throw new \RuntimeException(sprintf('No config found for host "%s"', $hostname));
    }

}